from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.EnhancedDiscussion import ed_globals
from cStringIO import StringIO
import string

cm="""threaded,Threaded
nested,Nested
minimal,Minimal
flat,Flat
dynamicThreaded,Dynamic Threaded
dynamicMinimal,Dynamic Minimal
none,None"""

def install(self):
    ###Add skin
    skinstool = getToolByName(self, 'portal_skins')
    if 'enhanced-discussion' not in skinstool.objectIds():
        addDirectoryViews(skinstool, 'skins', ed_globals )
        
    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if not 'enhanced-discussion' in path:
            try:
                idx = path.index( 'custom' )
            except ValueError:
                idx = 999
            path.insert( idx+1, 'enhanced-discussion' )
            path = string.join(path, ', ')
            skinstool.addSkinSelection(skin, path)
    
    ##Add site-wide comment options
    pt = getToolByName(self, 'portal_properties')
    sp = pt.site_properties
    
    if not sp.hasProperty('comment_modes'):
        sp.manage_addProperty(id='comment_modes', value=cm, type='lines')
        
    ##Add member_specific preferences
    mt = getToolByName(self, 'portal_memberdata')
    if not mt.hasProperty('pref_comment_mode'):
        mt.manage_addProperty(id='pref_comment_mode', value='threaded', type='string')
        
       
def uninstall(self):
    pt = getToolByName(self,  'portal_properties')
    if pt.site_properties.hasProperty('comment_modes'):
        pt.site_properties.manage_delProperties(['comment_modes',])
    
    mt = getToolByName(self, 'portal_memberdata')
    if mt.hasProperty('pref_comment_mode'):
        mt.manage_delProperties(['pref_comment_mode'])